''++ -------------------------------------------------------------------------
'' mandelbrot-fixed16-vga-512x384x1.bas
''
''                     translated to BASIC from mandelbrot16-20180406-fds.spin
''
'' set the VGA pin(group) as neede a few lines below.
''-- -------------------------------------------------------------------------

''++
'' set up VGA and preset the tiles' colors
''
dim vga as class using "VGA_512x384_Bitmap.spin"
''
dim shared as ulong sync
dim shared as ulong bitmap(vga.hp/32*vga.vp)
dim shared as ushort colors(vga.xtiles*vga.ytiles)
''
''        lowest pin of VGA pingroup
''        |
''        V
vga.start(16, @colors, @bitmap, @sync)
''
'' set set same colorpair for all tiles
''
for c=1 to vga.xtiles*vga.ytiles
  colors(c) = &b111111_00_000000_00 ' white on black
next c
''--

'++ ============================================================================

const xmin = (-21<<12)/10
const xmax = (  7<<12)/10

const ymin = (-12<<12)/10
const ymax = ( 12<<12)/10

const maxiter = 32

const MPX = vga.hp-1
const MPY = vga.vp-1

const dx = (xmax-xmin)/MPX
const dy = (ymax-ymin)/MPY

const c4 = 4<<12

dim as integer x,y,x2,y2,cx,cy,iter

cy = ymin
for py = 0 to MPY
  cx = xmin
  for px = 0 to MPX
    x = 0
    y = 0
    x2 = 0
    y2 = 0
    iter = 0
    while iter < maxiter and x2+y2 <= c4
      y = ((x*y)>>11)+cy
      x = x2-y2+cx
      iter = iter+1
      x2 = (x*x)>>12
      y2 = (y*y)>>12
    end while
    cx = cx+dx
    if iter and 1 then
      plot px,py
    end if
  next px
  cy = cy+dy
next py

''-- ===========================================================================

''++
do
loop
''--

''++
sub plot x,y
  var index = y<<4 + x>>5 + 1
  bitmap(index) = bitmap(index) or 1<<(x and 31)
end sub
''--
